package com.yerihyo.yeritools.collections;

import java.util.Comparator;

public class AlphaNumericComparator implements Comparator<String> {
	
	
	public static Integer parseInt(String s){
		Integer value = null;
		try{
			value = Integer.parseInt(s);
		}catch(NumberFormatException ex){
			return null;
		}
		return value;
	}
	public static Double parseDouble(String s){
		Double value = null;
		try{
			value = Double.parseDouble(s);
		}catch(NumberFormatException ex){
			return null;
		}
		return value;
	}
	@Override
	public int compare(String arg0, String arg1) {
		if(arg0==null){
			return -1;
		}else if(arg1==null){
			return 1;
		}
		
		Double int0 = parseDouble(arg0);
		Double int1 = parseDouble(arg1);
		if(int0!=null){
			if(int1!=null){
				double diff = int0-int1;
				return diff<0?(-1):(diff==0?0:1);
			}
			else{
				return -1;
			}
		}
		else{
			if(int1!=null){
				return 1;
			}
			else{
				return arg0.toLowerCase().compareTo(arg1.toLowerCase());				
			}
		}
	}

}
