package com.yerihyo.yeritools.csv;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Writer;
import java.nio.charset.Charset;

import com.yerihyo.yeritools.text.StringToolkit;

public class CSVToolkit {
	public static String[] getColumnNames(File csvFile) throws IOException {
		CSVReader reader = new CSVReader(new FileReader(csvFile));
		String[] line = reader.readNext();
		if(line==null){ return null; }
		
		
		for (int i=0; i<line.length; i++) {
			String aColumn = line[i];
			line[i] = aColumn.trim();
		}
		reader.close();
		
		return line;
	}

	
	public static void mergeCSVFiles(File[] fileArray, File ofile, Charset charset, boolean ignoreFirstLine, Writer progressWriter) throws IOException {
		PrintWriter writer = new PrintWriter(ofile);
		
		boolean isFirstFile = true;
		for(int i=0; i<fileArray.length; i++){
			File file = fileArray[i];
			BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), charset));
			if( (i+1)%100==0 && progressWriter!=null){
				progressWriter.write("mergeCSVFiles(): merging file #"+i+": "+file.getName()+StringToolkit.newLine() );
			}
			
			boolean isFirstLine = true;
			String oneline = null;
			while((oneline=reader.readLine())!=null){
				if(isFirstLine){
					isFirstLine = false;
					if(!isFirstFile && ignoreFirstLine){
						continue;
					}
				}
				
				oneline = oneline.trim();
				if(oneline.length()==0){ continue; }
				writer.println(oneline);
//				System.out.println(oneline);
			}
			reader.close();
			
			isFirstFile = false;
		}
		writer.close();
	}
}
